@Echo off
REM ~[960206] 24-nov-96 Bert Rector
REM ~ IDCNINST.OVL does not exist anymore do not delete
REM ~[970174] 03-Feb-98 Marius Groenendijk & Peter de Vos
REM ~ Enable installation from hard-drive in stead of from floppies.
REM ~ This is relevant when installing an installation downloaded from the Internet.
REM ~[980086] 20-Mar-98 Marius Groenendijk
REM ~ Enable installation from CD-ROM.
REM ~[980037] 20-Mar-98 Marius Groenendijk
REM ~ On some systems (e.g. NT) it's just not possible to create a directory in \
REM ~ Allow alternate temporary directory
REM ************************************************************************
REM       Validation of INSTALL input parameter 1
REM ************************************************************************

REM ~[970174] Unpack self-extracting CORE and CN8 chunks file if available
REM Cannot use FOR ... on some systems.
IF EXIST CORE.EXE CORE.EXE -o >NUL
IF EXIST CORE.EXE DEL CORE.EXE >NUL
IF EXIST CN8_1_6.EXE CN8_1_6.EXE -o >NUL
IF EXIST CN8_2_6.EXE CN8_2_6.EXE -o >NUL
IF EXIST CN8_3_6.EXE CN8_3_6.EXE -o >NUL
IF EXIST CN8_4_6.EXE CN8_4_6.EXE -o >NUL
IF EXIST CN8_5_6.EXE CN8_5_6.EXE -o >NUL
IF EXIST CN8_6_6.EXE CN8_6_6.EXE -o >NUL
IF EXIST CN8_?_6.EXE DEL CN8_?_6.EXE >NUL

IF %5x == x GOTO Firstcall
IF %5 == 2  GOTO StartInst2

:Firstcall

REM ~[970174] HDD/CDROM/download installation?
IF %1==A:  GOTO NoHDD
IF %1==B:  GOTO NoHDD
IF %1==a:  GOTO NoHDD
IF %1==b:  GOTO NoHDD

REM ~[980086] test for IDEP-CDROM identification.
REM ~ This is a special 'marker-file' called IDEPCN8.ROM (!)
REM ~ We consider a CD-ROM to be a 'large' Floppy. Install as if from floppy.
IF NOT EXIST IDEPCN8.ROM GOTO HDDOk
IF %1x == %2x GOTO CDNotOK
GOTO NoHDD


:HDDOk
REM ~[970174] If HDD/download installation create XXXYYYZZ.III dir as SubDir of Download dir
Md XXXYYYZZ.III  > NUL
Cd XXXYYYZZ.III  > NUL
COPY ..\PKUNZIP.EXE  > NUL
IF NOT EXIST ..\PKUNZIP.EXE GOTO ERROR2

COPY ..\CN8UPD.BAT > NUL
COPY ..\TEXT.BAT   > NUL

PKUNZIP -o -3 ..\INSTALL  > NUL

GOTO StrtUpd

REM *** Normal floppy installation (or CDROM) ***
:NoHDD
%2
CD \

REM **** Inexisting destination drive (syntax error or inexisting drive) ***
REM **** if the temporary directory could not be created and PKUNZIP *******
REM **** not copied into the directory *************************************

MD XXXYYYZZ.III  > NUL
COPY %1PKUNZIP.EXE XXXYYYZZ.III > NUL

REM ~[980086] On some systems (e.g. NT) it's just not possible to create a directory in \
REM ~ ref [980037]

IF NOT EXIST XXXYYYZZ.III\PKUNZIP.EXE GOTO TryTemp
CD XXXYYYZZ.III  > NUL
GOTO Continue

REM Try TEMP check if it's a writable directory. You may get 'Unable to create ...' or '
REM Path not Found...' messages). This is to avoid using IF EXIST %TEMP\NUL which may
REM not be portable

:TryTemp
IF x%TEMP% == x GOTO NoTemp

MD %TEMP%\XXXYYYZZ.III > NUL
COPY %1PKUNZIP.EXE %TEMP%\XXXYYYZZ.III > NUL

IF NOT EXIST %TEMP%\XXXYYYZZ.III\PKUNZIP.EXE GOTO NoTemp

REM Select drive and directory of TEMP
COPY %1CHDRIVE.BAT %TEMP%\XXXYYYZZ.III > NUL
CALL %1CHDRIVE %TEMP%\XXXYYYZZ.III > NUL
GOTO Continue

:NoTemp
CLS
CALL %1TEXT 13
PAUSE

GOTO End
REM ~[980086] End change


:Continue
REM ~[980086]
IF EXIST %1IDEPCN8.ROM COPY %1IDEPCN8.ROM > NUL

COPY %1CN8UPD.BAT > NUL
COPY %1TEXT.BAT   > NUL

PKUNZIP -o -3 %1INSTALL  > NUL

:StrtUpd
CN8UPD %1 %2 %3 %4 2

:StartInst2

IDCNINST.EXE %1 %2 0 3 %4

DEL PKUNZIP.EXE  > NUL
DEL IDCNINST.EXE  > NUL
REM ~[960206] IDCNINST.OVL does not exist anymore.
REM ~ DEL IDCNINST.OVL > NUL
DEL I_*.DB*  > NUL
DEL *.MEM  > NUL
DEL *.NSX  > NUL

REM ~[980086]
IF EXIST IDEPCN8.ROM DEL IDEPCN8.ROM > NUL

REM Not useful
REM IF NOT EXIST ZIP_EX.ZIP GOTO REMDIR
REM DEL ZIP_EX.ZIP > NUL

:REMDIR

REM ~[970174] Remdir is on the hdd or floppy
IF EXIST ..\REMDIR.BAT ..\REMDIR %1 HDD
REM use %1REMDIR i.s.o %1\REMDIR
IF NOT EXIST ..\REMDIR.BAT %1REMDIR %2 FLOPPY

GOTO end

REM ************************************************************************
REM       Error handling routine in case of erroneous input parameters 
REM ************************************************************************

REM ~[980086] Can't write to CD!
:CDNotOK
Cls
CALL TEXT 12
GOTO end

:ERROR2

DEL PKUNZIP.EXE  > NUL
CD ..
RD XXXYYYZZ.III  > NUL
Cls

REM ~[970174]
IF NOT EXIST TEXT.BAT GOTO BadInst
CALL TEXT 12

GOTO end

REM ~[970174] Something is really wrong.

:BadInst
ECHO Please check that you have downloaded 'CORE.ZIP'
ECHO Configuration incomplete. Installation aborted.

:end
                      
